function p=Horner(d,x,xe)
%--------------------------------------------------------------------------
% This function implements the Horner scheme for evaluating
% the interpolating polynomial in Newton form on a set of evaluation points
%--------------------------------------------------------------------------
% Inputs
% d: divided differences vector
% x: vector of interpolating points
% xe: vector of evaluation points
%
% Output
% p: the polynomial evaluated at all targets
%-----------------------------------------------
n=length(d);
for i=1:length(xe);
p(i)=d(n);
for k=n-1:-1:1
p(i)=p(i)*(xe(i)-x(k))+d(k);
end
end