clear all 
close all

% ESERCIZIO 1 del 7 luglio 2017

f=@(x) exp(sin(x));
i=1;

I=quadl(f,0,10, 1.e-8); %valore "esatto" dell'integrale

% questo serve per fare il ciclo richiesto al punto (d)
NN=[10, 20, 30, 50, 70 100 150]; 

for N=NN
x=linspace(0,10,N)';

%punto (a)
p1=vander(x)\f(x);
v=(10.^(N:-1:1)./(N:-1:1))'; %vettore degli x^(n+1)/(n+1) per x=10 (per x=0 fa 0)
I1=p1'*v; %p-1 x^(n+1)/(n+1) + ...+ p_n x fornisce la stima dell'integrale richiesto
err_a(i)=abs(I-I1)/abs(I);

%punto (b)
p2=polyfit(x,f(x),length(x)-1)';
I2=p2'*v;
err_b(i)=abs(I-I2)/abs(I);

%punto (c)
h=10/N;
w_tr=(h/2)*[1; 2*ones(N-2,1); 1];
I_tr=f(x)'*w_tr;

err_c(i)=abs(I-I_tr)/abs(I);
i=i+1;
end


plot(NN,log10(err_a),'r*-', NN,log10(err_b),'g*-',NN,log10(err_c),'b*-')
legend('vander','polyfit','trapezoidal')

errors=table(err_a',err_b',err_c')


%punto d
% sebbene per N<=50 calcolare l'integrale con il polimomio interpolante 
% dia un errore minore, ci si accorge che al crescere di N l'errore aumenta
% molto rapidamente. In particolare il metodo del punto a) da un errore
% molto grande in quanto la matrice di Vandermonde assume un numero di
% condizionamento molto alto per N grande e l'errore nella stima del polinomio
% interpolante risulta elevato.
% Viceversa il metodo dei trapezi fornisce una stima poco precisa (l'ordine 
% dell'errore 10^-2) ma stabile al variare di N.
